<template>
  <div class="memo-app">
    <memo-form @addMemo="addMemo" />
    <ul class="memo-list">
      <memo
        v-for="memo in memos"
        :key="memo.id"
        :memo="memo"
        @deleteMemo="deleteMemo"
        @updateMemo="updateMemo"
      />
    </ul>
  </div>
</template>
<script>
import MemoForm from "./MemoForm";
import Memo from "./Memo";
import axios from "axios";

const memoAPICore = axios.create({
  baseURL: "http://localhost:8000/api/memo"
});

export default {
  name: "MemoApp",
  data() {
    return {
      memos: []
    };
  },
  created() {
    this.retrieveMemo();
  },
  components: {
    MemoForm,
    Memo
  },
  methods: {

    /* 메모 조회 */
    retrieveMemo() {
      memoAPICore.get("/").then(res => {
        console.log("요청이 성공하였습니다.")
        
        this.memos = res.data;
        console.log(this.memos);
      }).catch(error => {
          console.error("요청에 실패 했습니다.", error);
      });
    },

    /* 메모 추가 */
    addMemo(payload) {
      memoAPICore.post("/", payload).then(res => {
        console.log(payload);
        this.retrieveMemo();
      }).catch(error => {
          console.error("요청에 실패 했습니다.", error);
      });
    },

    /* 메모 삭제 */
    deleteMemo(id) {
      
      memoAPICore.delete(`/${id}`).then(res => {
          this.retrieveMemo();
      }).catch(error => {
          console.error("요청에 실패 했습니다.", error);
      });
    },

    /* 메모 수정 */
    updateMemo(payload) {
      const { id, content, title } = payload;
      console.log(id + ", " + content + ", " + title);
      memoAPICore.put("/", payload).then(res => {
          this.retrieveMemo();
      }).catch(error => {
          console.error("요청에 실패 했습니다.", error);
      });
    }
  }
};
</script>

<style scoped>
.memo-list {
  padding: 20px 0;
  margin: 0;
}
</style>

